/* 
Motor Pas a Pas moviment per graus
Gira els graus que li indiquem des del monitor sèrie 
El motor necessita de 512 passos per recórrer els 360 graus d'una volta.
                                             360      1
El factor de conversió de graus a voltes és: --- = -------
                                             512   1,42222
*/

int retard         = 5;  // Temps de retard entre els passos del motor
int numPasos       = 0;  // Guarda en graus el punt on es troba el motor
String caracters;        // Cadena entrada per l'usuari
int graus;               // Valor en graus de la cadena entrada per l'usuari


void setup() {                
Serial.begin(9600);     // Inicialització del port sèrie a 9600 baudis
pinMode(11, OUTPUT);    // Pin 11 conectat a IN4 del mòdul ULN2003
pinMode(10, OUTPUT);    // Pin 10 conectat a IN3 del mòdul ULN2003
pinMode(9, OUTPUT);     // Pin  9 conectat a IN2 del mòdul ULN2003
pinMode(8, OUTPUT);     // Pin  8 conectat a IN1 del mòdul ULN2003
}

void loop() {
  while (Serial.available()) {          // Espera l'entrada d'un valor per l'usuari
    delay(retard);
    char c  = Serial.read();            // Crea la variable "c" que llegeix els bytes entrats per l'usuari
    caracters += c;                     // Converteix en cadena de caràcters els diferents bytes llegits
  }  
  if (caracters.length()>0){       
        graus = caracters.toInt();      // Converteix la cadena de caràcters a número enter
         Serial.print("Posició del motor: ");           // Envia per pantalla la posició del motor en graus
         Serial.print(numPasos/1.4222222222);
         Serial.println(" graus");
         Serial.print("Posició demanada: ");           // Envia per pantalla el valor entrat en graus
         Serial.print(graus);
         Serial.println(" graus");
         Serial.println(" ");  
         Serial.println("Escriu un número entre 0 i 360: ");  
        delay(retard);
        graus = (graus * 1.4222222222); // Ajusta els 512 passos de cada volta als 360 graus
  }  

   while (graus>numPasos){              // Gira a l'esquerra en graus
       pasEsquerra();
       numPasos = numPasos + 1;
   }
   while (graus<numPasos){              // Gira a la dreta en graus
        pasDreta();
        numPasos = numPasos -1;
   }
  caracters = "";                      // Inicialitzem la cadena de caràcters
  atura();                             // Atura del motor per tal d'evitar que es calenti
}

void pasDreta(){         // Pasos a la dreta
 digitalWrite(11, LOW); 
 digitalWrite(10, LOW);  
 digitalWrite(9, HIGH);  
 digitalWrite(8, HIGH);  
   delay(retard); 
 digitalWrite(11, LOW); 
 digitalWrite(10, HIGH);  
 digitalWrite(9, HIGH);  
 digitalWrite(8, LOW);  
   delay(retard); 
 digitalWrite(11, HIGH); 
 digitalWrite(10, HIGH);  
 digitalWrite(9, LOW);  
 digitalWrite(8, LOW);  
  delay(retard); 
 digitalWrite(11, HIGH); 
 digitalWrite(10, LOW);  
 digitalWrite(9, LOW);  
 digitalWrite(8, HIGH);  
  delay(retard);  
}

void pasEsquerra() {        // Pasos a l'esquerra
 digitalWrite(11, HIGH); 
 digitalWrite(10, HIGH);  
 digitalWrite(9, LOW);  
 digitalWrite(8, LOW);  
  delay(retard); 
 digitalWrite(11, LOW); 
 digitalWrite(10, HIGH);  
 digitalWrite(9, HIGH);  
 digitalWrite(8, LOW);  
  delay(retard); 
 digitalWrite(11, LOW); 
 digitalWrite(10, LOW);  
 digitalWrite(9, HIGH);  
 digitalWrite(8, HIGH);  
  delay(retard); 
 digitalWrite(11, HIGH); 
 digitalWrite(10, LOW);  
 digitalWrite(9, LOW);  
 digitalWrite(8, HIGH);  
  delay(retard); 
}
        
void atura() {         // Atura del motor
 digitalWrite(11, LOW); 
 digitalWrite(10, LOW);  
 digitalWrite(9, LOW);  
 digitalWrite(8, LOW);  
 }

